/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui.okcancelpanel;

import java.awt.Dimension;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

public class ClosePanel extends JPanel{

	private static final long serialVersionUID = 1L;

	private JButton closeButton;
	
	public ClosePanel(final Window window,  String caption,final boolean dispose) {
		closeButton = new JButton(caption);
		closeButton.setPreferredSize(new Dimension(closeButton.getMinimumSize().width, 30));
		closeButton.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				if (dispose)
					window.dispose();
				else
					window.setVisible(false);				
			}
		});
		add(closeButton);
	}
	
	public ClosePanel(final Window window,  String caption) {
		this(window, caption, false);
	}
	
	public JButton getCloseButton() {
		return closeButton;
	}
}
