/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package gui.transfer;

import gui.layout.PercentageLayout;
import gui.resource.ResourceManager;

import java.awt.Dimension;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JSeparator;

import static gui.util.GuiUtil.*;

public class InfoPanel extends JPanel {

	private static final String
		LOCALE_SPEED="speed",
		LOCALE_FINISHED="statusFinished",	
		LOCALE_TRANSFERRED="transferred"
	;
	
	private static final long serialVersionUID = 1L;
	private JLabel lblProgress,lblSpeed,lblBytes;
	private JProgressBar progressBar;	
	private ResourceManager rm;
	
	public InfoPanel(ResourceManager rm) {
		this.rm=rm;
		setLayout(new PercentageLayout());
		
		Dimension d=new Dimension(640, 24);
		setMinimumSize(d);
		setPreferredSize(d);
		
		lblSpeed=new JLabel(rm.getLocalizedString(LOCALE_SPEED)+": "+formatSpeed(0L));
		lblProgress=new JLabel(rm.getLocalizedString(LOCALE_FINISHED)+": 0/0");
		lblBytes=new JLabel(rm.getLocalizedString(LOCALE_TRANSFERRED)+": "+formatBytes(0L));
		progressBar=new JProgressBar(0,100);
		add(lblSpeed, PercentageLayout.constraints(1, 0, 25, 100));
		add(getSeparator(),PercentageLayout.constraints(26, 0, 2, 100));
		add(lblBytes,PercentageLayout.constraints(28, 0, 25, 100));
		add(getSeparator(),PercentageLayout.constraints(53, 0, 2, 100));
		add(lblProgress,PercentageLayout.constraints(55, 0, 25, 100));
		add(progressBar,PercentageLayout.constraints(80, 0, 20, 100));		
	}
	private JSeparator getSeparator() {
		return new JSeparator(JSeparator.VERTICAL);
	}
	
	
	public void update(long bytes,int doneFiles,int totalFiles) {
		
		lblBytes.setText(rm.getLocalizedString(LOCALE_TRANSFERRED)+": "+formatBytes(bytes));
		lblProgress.setText(rm.getLocalizedString(LOCALE_FINISHED)+": "+doneFiles+"/"+totalFiles);
		if (totalFiles>0)
		progressBar.setValue(doneFiles*100/totalFiles);
		else
		progressBar.setValue(0);	
		
	}
	
	public void updateSpeed(long speed) {
		lblSpeed.setText(rm.getLocalizedString(LOCALE_SPEED)+": "+formatSpeed(speed));
	}
}
