/*	This program is released under GNU General Public License (see COPYING).
 *  It comes AS IS and without any warranty 
 *  (C) 2010 TCM, Open Source Maniax
 */

package gui.util.buttonhandler;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.AbstractButton;

public class ButtonHandler {
	protected List<AbstractButton> buttons;
	protected ButtonHandlerListener listener;
	private int selectedIndex;
	
	public void setListener(ButtonHandlerListener listener) {
		this.listener = listener;
	}
	
	public ButtonHandler() {
		buttons=new ArrayList<>();
		selectedIndex=-1;
	}
	
	public ButtonHandler(AbstractButton... bts) {
		this();
		add(bts);
	}
	
	public void add(final AbstractButton button) {
		buttons.add(button);
			button.addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent e) {
					setSelectedButton(button);		
				}
			});
	}
	
	public void add(AbstractButton... bts) {
		for (final AbstractButton button:bts) {
			buttons.add(button);
			button.addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent e) {
					setSelectedButton(button);		
				}
			});
		}
	}
	
	public void setSelectedButton(AbstractButton buttonToSelect ) {
		for (int i=0;i<buttons.size();i++) {
			AbstractButton b=buttons.get(i);
			b.setSelected(false);
			if (b==buttonToSelect)selectedIndex=i;
		}
		buttonToSelect.setSelected(true);
		if (listener!=null) listener.indexChanged(selectedIndex);
	}

	public int getSelectedIndex() {
//		int i=0;
//		for (AbstractButton button:buttons) {
//			if (button.isSelected()) {
//				return i;
//			} else {
//				i++;
//			}
//		}
//		
//		return -1;
		return selectedIndex;
	}

	public void setSelectedButton(int index) {
		if (index>=0 && index<buttons.size()) {
			setSelectedButton(buttons.get(index));
		} else {
			setSelectedButton(buttons.get(0));
		}
	}

	public int getCount() {
		return buttons.size();
	}
}
