/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package model.transfer;

import java.util.List;

public abstract class Status {
	public static final Status loading;
	public static final Status stopped;
	public static final Status finished;
//	public static final Status error;
	public static final Status queued ;
	public static final Status remove;
	
	private String disp;
	
	public void setDispName(String s) {
		disp=s;
	}
	
	@Override
	public String toString() {
		return disp;
	}
	
	static {
		loading = new Status() {
			@Override
			public void update(List<TransferObserver> obs, TransferInfo info){
				for (TransferObserver o:obs) o.updateSpeed(info);					
			}
		};
		stopped = new Status() {

			@Override
			public void update(List<TransferObserver> obs, TransferInfo info){
				info.setLockCancel(true);
				for (TransferObserver o:obs) o.updateStopTransfer(info);			
			}
			
		};
		finished=new Status() {
			
			@Override
			public void update(List<TransferObserver> obs, TransferInfo info){
				for (TransferObserver o:obs) o.updateTransferFinished(info);
			}
		};
//		error=new Status() {
//			
//			@Override
//			public void update(List<TransferObserver> obs, TransferInfo info){
//				for (TransferObserver o:obs) o.updateError(info);
//			}
//		};
		queued=new Status() {
			
			@Override
			public void update(List<TransferObserver> obs, TransferInfo info){
				info.setLockCancel(false);
				for (TransferObserver o:obs) o.updateEnqueue(info);				
			}
		};
		remove=new Status() {
			
			@Override
			public void update(List<TransferObserver> obs, TransferInfo info) {
				for (TransferObserver o:obs) o.updateRemoveTransfer(info);			
			}
		};
	}
	
	public abstract void update(List<TransferObserver> obs,TransferInfo info);
}
