/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package model.transfer;

import java.io.IOException;
import java.util.List;

import net.util.Proxy;

public interface TransferManager<T extends TransferObserver> {

	int getFileCounter();

	int getNumberOfFiles();
	
	long getTransferredBytes();
//	long getTotalSpeed();

	void startStopAll() throws IOException;
	void stopAll() throws IOException;
	void startAll() throws IOException;
//	void start();
	void removeAll();
	void remove(int id);
	void stopEnqueue(int id) throws IOException;
	void addObserver(T o);
	void setTimeout(int timeout);
	void setProxy(Proxy proxy);
	List<TransferInfo> getUnfinished();
	void setMaxThreads(int threads);
	void setMaxTries(int tries);

}
