/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package net.util;

import static shoshone.httpclient.UrlUtil.*;

public class LinkExtractorByHtmlElement extends LinkExtractor {
	
	private static LinkExtractor linkExtractor= new LinkExtractorByHtmlElement();
	
	public static LinkExtractor getLinkExtractor() {
		return linkExtractor;
	}
	
	@Override
	public String getLink(String url,String html,String[] args) {

		String elementName=args[0];
		String elementValue=args[1];
		String tokenName=args[2];
		
		String l=preFilterHtml(html);
		
		StringBuilder token1=new StringBuilder(elementName);
		token1.append('=');
		token1.append(delimiter);
		token1.append(elementValue );
		token1.append(delimiter);
		
		int pos=l.indexOf(token1.toString());
		
		if (pos==-1) return null;
		
		int pos2=l.lastIndexOf('<', pos);
		//int pos3=l.indexOf('>', pos);
		
		String s=l.substring(pos2);
		String token=tokenName+'=';
		int start= s.indexOf(token)+token.length()+1;
		int end = s.indexOf(delimiter, start+1);
		
		return URLDecoder.decode(getAbsolutePath(s.substring(start, end),url));
	}

	@Override
	public String[] getArgNames() {
		return new String[]{"elementName","elementValue","linkElementName"};
	}
	
}
