/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package net.util;
import static shoshone.httpclient.UrlUtil.*;

public class LinkExtractorByKeyNoDelimiter extends LinkExtractor{

	private static LinkExtractor linkExtractor= new LinkExtractorByKeyNoDelimiter();
	
	public static LinkExtractor getLinkExtractor() {
		return linkExtractor;
	}
	
	private LinkExtractorByKeyNoDelimiter() {
		
	}
	
	@Override
	public String getLink(String url, String html,String[] args) {
		String key=args[0];
		String token=args[1];
		String delim=">";
		if (args[2]!=null) delim=args[2];
		String s=html;
		
		int k=s.indexOf(key);
		
		String t=token+'=';
		
		int start=s.lastIndexOf(t, k)+t.length();
		int end=s.indexOf(delim, start);
		return URLDecoder.decode(getAbsolutePath(s.substring(start, end), url));
	}

	@Override
	public String[] getArgNames() {
		return new String[]{"value","linkElementName","delimiter"};
	}

}
