/*	License
 * 		inside EU: EUPL
 * 		outside EU: GPL or EUPL
 *  The program comes AS IS and without any warranty unless required by law
 *  (C) 2012 thecodemonkey
 */

package net.util;
import static shoshone.httpclient.UrlUtil.*;

public class LinkExtractorByKeyStartEnd extends LinkExtractor{

	private static LinkExtractor linkExtractor= new LinkExtractorByKeyStartEnd();
	
	public static LinkExtractor getLinkExtractor() {
		return linkExtractor;
	}
	
	private LinkExtractorByKeyStartEnd() {
		
	}
	
	@Override
	public String getLink(String url, String html,String[] args) {
		String keyStart=args[0];
		String keyEnd=args[1];
		
		String s=preFilterHtml(html);
		
		int start=s.indexOf(keyStart)+keyStart.length();
		if (start==-1 ) return null;
		
		int end=s.indexOf(keyEnd, start+1);
		if (end==-1 ) return null;
		return URLDecoder.decode(getAbsolutePath(s.substring(start, end), url));
	}

	@Override
	public String[] getArgNames() {
		return new String[]{"start","end"};
	}

}
