package shoshone.httpclient;

import java.io.IOException;
import java.io.InputStream;

public class ByteBuffer extends InputStream{
	private byte[] arr;
	private int counter;
	
	public ByteBuffer(int cap) {
		counter=0;
		arr=new byte[cap];
	}
	
	public void put(int b) {
		arr[counter++] = (byte) b;
	}
	
	public void put(byte b) {
		arr[counter++] = b;
	}
	
	public void reset() {
		counter=0;
	}
	
	public boolean atLimit() {
		if (counter==arr.length) {
			counter=0;
			return true; 
		} else {
			return false;
		}
	}
	
	public int getSize() {
		return counter;
	}

	@Override
	public int read() throws IOException {
		return atLimit()?-1:arr[counter++];
	}
}
