package util;


public class StringUtil {
//	public static void main(String[] args) throws IOException {
//		String s=new String(Files.readAllBytes(Paths.get("test.txt")));
//		long l=System.currentTimeMillis();
//		System.out.println(dropAll(s, ' ','\t','\r','\n'));
//		//System.out.println(s.replaceAll("\u0020|\t|\r\n", ""));
//		System.out.println(System.currentTimeMillis()-l);
//	}
	
	/**
	 * Removes all instances of the characters in the parameter array
	 */
	public static String dropAll(String s,char... drop) {
		StringBuilder sb=new StringBuilder(s.length());
		for (int i=0;i<s.length();i++) {
			char c=s.charAt(i);
			if (!contains(drop, c))
				sb.append(c);
		}
		
		return sb.toString();
	}
	
	
	private static boolean contains(char[] cArr,char c){
		for (int i=0;i<cArr.length;i++){
			if (cArr[i]==c) return true;
		}
		return false;
	}
	
	/**
	 * Replaces all instances of a single char in a string
	 * 
	 * @param s source string
	 * @param oldC char that should be replaced
	 * @param newC char to replace with
	 */
	public static String replaceAll(String s,char oldC,char newC) {
		char[] chrs=s.toCharArray();
		for (int i=0;i<chrs.length;i++) {
			if (chrs[i] == oldC)
				chrs[i] = newC;
		}
		return new String(chrs);
	}
	
	/**
	 * Faster replacing of all instances of a <b>non-regex</b> String
	 * @param s source string
	 * @param oldStr substring to be replaced
	 * @param newStr string to replace with
	 */
	public static String replaceAll(String s,String oldStr,String newStr){
		StringBuilder sb=new StringBuilder();
		int i=0;
		while (i<s.length()){
			boolean found=true;
			
			int k=0;
			for (int j=0;j<oldStr.length();j++) {
				if (s.charAt(i+j)!=oldStr.charAt(j) ) {
					k=j;
					found=false;
					break;
				}
			}
			
			if (found) {
				sb.append(newStr);
				i+=oldStr.length();
			} else if (k>0) {
				sb.append(s.substring(i, i+k));
				i+=k;
			} else {
				sb.append(s.charAt(i));
				i++;
			}
		}
		return sb.toString();
	}
	
	/**
	 * Faster replacing of the first instance of a <b>non-regex</b> String
	 * @param s source string
	 * @param oldStr substring to be replaced
	 * @param newStr string to replace with
	 */
	public static String replaceFirst(String s,String oldStr,String newStr){
		int k=s.indexOf(oldStr);
		return k>-1?s.substring(0, k)+newStr+s.substring(k+oldStr.length()):s;
	}
	
	public static String dropFirst(String s,String drop) {
		int k=s.indexOf(drop);
		if (k==0){
			return s.substring(drop.length());
		} else{
			return k>-1?s.substring(0, k)+s.substring(k+drop.length()):s;
		}
	}
}
